#include "mbed.h"
#include "EthernetInterface.h"
#include "Websocket.h"
#include <string.h>
#include <stdlib.h>
#include  <stdio.h>
DigitalOut myled(LED1);
DigitalOut led2(LED2);
Serial pc(USBTX, USBRX);

Websocket ws("ws://api.cosm.com:8080/feeds/");

const char apikey[] = "YOURAPIKEY";
const char feed[]= "/feeds/YOURFEEDID"; //
char cms[1024];

EthernetInterface eth;
#define interval    5   //seconds

float   windaverage=12.1f;
float   windgust=14.1f;
float   tempbuiten=15.1f;
float   tempbinnen=16.1f;
float   sensor1=17.2f;
float   sensor2=18.2f;
float   sensor3=19.2f;
float   regen=1.2f;
float   hpa=1024.1f;

int token = 0;
//rtos timer
void Interrupts_thread (void const *argument)
{
    while (true) {
        myled = !myled;
        sprintf (cms,"{\"method\" : \"put\",\"resource\" : \"%s\",\"params\" : {},\"headers\" : {\"X-ApiKey\":\"%s\"},\
               \"body\" :{\"version\" : \"1.0.0\",\"datastreams\" :[\
               {\"id\" : \"0\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"1\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"2\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"3\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"4\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"5\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"6\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"7\",\"current_value\" : \"%2.1f\"},\
               {\"id\" : \"8\",\"current_value\" : \"%2.1f\"}\
               ]},\"token\" : \"0x%d\"}\r\n",feed,apikey,\
                 windaverage,windgust,tempbuiten,tempbinnen,sensor1,sensor2,sensor3,regen,hpa,\
                 token);
        printf ("%s\r\n",cms);
        token++;
        int res = ws.send(cms);

        if(ws.read(cms)) {
            pc.printf("rcv: %s\r\n", cms);


        }

        Thread::wait(interval*1000);
    }
}

///main body
int main()
{

    pc.baud(460800);
    myled=0;
    led2=0;
    eth.init(); //Use DHCP

    eth.connect();
    pc.printf("IP Address is %s\r\n", eth.getIPAddress());

    ws.connect();
    if(ws.read(cms)) {
        pc.printf("rcv: %s\r\n", cms);
    }
    Thread thread2(Interrupts_thread);
    while (1) {
        led2=!led2;
        wait(1);
    }

}
